import org.apache.hadoop.mapred.*;
import org.apache.hadoop.io.*;
import org.apache.hadoop.fs.*;
import org.apache.hadoop.conf.Configuration;

import edu.umass.cs.mallet.base.classify.*;
import edu.umass.cs.mallet.base.pipe.*;
import edu.umass.cs.mallet.base.pipe.iterator.*;
import edu.umass.cs.mallet.base.types.*;
import edu.umass.cs.mallet.base.util.*;

import java.io.*;
import java.util.*;

public class Project1Reducer extends MapReduceBase implements Reducer {
    
    static int correct = 0;
    static int total = 0;
    static JobConf job = null;

    public void configure(JobConf j) {
	job = j;
    }

    public void close() throws IOException {
	Path p = new Path("output/accuracy");
	FileSystem fs = p.getFileSystem(job);
	FSDataOutputStream fsdis = fs.create(p);
	PrintStream ps = new PrintStream(fsdis);
	ps.println("accuracy: " + ((double)correct/(double)total));
	ps.close();
    }

    public void reduce(WritableComparable key, Iterator values,
		       OutputCollector output, Reporter reporter) 
	throws IOException {
	while (values.hasNext()) {
	    Text t = (Text)values.next();
	    if (key.toString().contains(t.toString())) {
		correct++;
	    }
	    total++;
	}
    }
}
